## kamailio 4.3.1

=== Makefile ===
# Kamailio makefile
#
# WARNING: requires gmake (GNU Make)
#  Arch supported: Linux, FreeBSD, SunOS (tested on Solaris 8), OpenBSD (3.2),
#  NetBSD (1.6), OS/X
#

# check make version
# everything works with 3.80, except evals inside ifeq/endif
# (see https://savannah.gnu.org/bugs/index.php?func=detailitem&item_id=1516).
# recommended 3.81
req_ver=3.81
# the check below works for version number of the type x.yy or x.yy.z*
# (from the GNU Make Cookbook)
ifeq (,$(filter $(req_ver),$(firstword $(sort $(MAKE_VERSION) $(req_ver)))))
$(error make version $(MAKE_VERSION) not supported, use at least $(req_ver))
endif


auto_gen=lex.yy.c cfg.tab.c #lexx, yacc etc
auto_gen_others=cfg.tab.h # auto generated, non-c
auto_gen_keep=autover.h # auto generated, should be included in archives

COREPATH=.
#include  source related defs
include Makefile.sources
#include special targets lists
include Makefile.targets

# whether or not the entire build process should fail if building a module or
#  an utility fails
err_fail?=1

# whether or not to install $(MAIN_NAME).cfg or just $(MAIN_NAME).cfg.default
# ($(MAIN_NAME).cfg will never be overwritten by make install, this is usefull
#  when creating packages)
skip_cfg_install?=

#extra modules to exclude
skip_modules?=

# see Makefile.dirs for the directories used for the modules
include Makefile.dirs

# Set document format
# Alternatives are txt, html, xhtml, and pdf (see Makefile.doc)
doc_format?=html

# don't force modules.lst generation if the makefile goals do not
# require it (but if present use it)
ifeq (,$(strip $(filter-out $(clean_targets) $(aux_targets),$(MAKECMDGOALS))))
ifneq (,$(strip $(wildcard modules.lst)))
-include modules.lst
endif
else
include modules.lst
endif # ifneq (,$(strip $(filter-out ...,$(MAKECMDGOALS))))

#if called with group_include, ignore the modules from modules.lst
ifneq ($(group_include),)
	include_modules=
	exclude_modules=
	modules_configured:=0
endif

# get the groups of modules to compile
include Makefile.groups

# - automatically build the list of excluded modules
# if not set on the cmd. line, env or in the modules.lst (cfg_group_include)
# exclude the below modules.
ifneq ($(group_include)$(cfg_group_include),)
	# For group_include, default all modules are excluded except those in
	# include_modules
	exclude_modules?=
else
	# Old defaults for backwards compatibility
	# excluded because they depend on external libraries
ifeq ($(origin exclude_modules), undefined)
	exclude_modules:= $(sort \
				$(filter-out $(module_group_default), $(mod_list_all)))
endif
endif

# always add skip_modules list - it is done now in modules.lst (dcm)
# override exclude_modules+= $(skip_modules)

# Test for the groups and add to include_modules
ifneq (,$(group_include))
$(eval override include_modules+= $(foreach grp, $(group_include), \
										$(module_group_$(grp)) ))
endif

ALLDEP=config.mak Makefile Makefile.dirs Makefile.sources Makefile.rules

#include general defs (like CC, CFLAGS  a.s.o)
# hack to force makefile.defs re-inclusion (needed when make calls itself with
# other options -- e.g. make bin)
#makefile_defs=0
#C_DEFS:=


# try saved cfg, unless we are in the process of building it or if we're doing
# a clean
ifeq (,$(strip \
	$(filter config.mak config cfg cfg-defs $(clean_targets),$(MAKECMDGOALS))))
include config.mak
ifeq ($(makefile_defs),1)
ifeq ($(quiet),verbose)
$(info config.mak loaded)
endif # verbose
export makefile_defs
# config_make valid & used
config_mak=1
ifeq ($(MAIN_NAME),)
$(error "bad config.mak, try re-running make cfg")
endif
endif
else # config.mak doesn't need to be used
ifneq (,$(filter cfg config cfg-defs,$(word 1,$(MAKECMDGOALS))))
# needed here to avoid starting a config submake 
# (e.g. rm -f config.mak; make config.mak), which would either require 
# double Makefile.defs defines execution (suboptimal), would loose
# $(value ...) expansion or would cause some warning (if Makefile.defs exec. 
# is skipped in the "main" makefile invocation).
$(shell rm -rf config.mak)
config_mak=0
makefile_defs=0
exported_vars=0
else
# config.mak not strictly needed, but try to load it if exists for $(Q)
config_mak=skip
-include config.mak
export makefile_defs
endif
endif


main_makefile=1
include Makefile.defs

static_modules_path=$(addprefix modules/, $(static_modules))
extra_sources=$(wildcard $(addsuffix /*.c, $(static_modules_path)))
extra_objs=$(extra_sources:.c=.o)

static_defs:= $(foreach  mod, $(static_modules), \
		-DSTATIC_$(shell echo $(mod) | tr [:lower:] [:upper:]) )

override extra_defs+=$(static_defs) $(EXTRA_DEFS)
export extra_defs

# Historically, the resultant set of modules is: modules/* - exclude_modules +
# include_modules
# When group_include is used, we want: include_modules (based on group_include)
# - exclude_modules

ifneq ($(modules_configured),1) 
#modules_all=$(filter-out modules/CVS,$(wildcard modules/*))

# create modules*_all vars
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_all=$$(filter-out $(mods)/CVS,$$(wildcard $(mods)/*))))
#debugging
#$(foreach mods,$(modules_dirs),$(info "$(mods)_all=$($(mods)_all)"))

ifneq ($(group_include),)
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)=$$(filter-out $$(addprefix $(mods)/, \
			$$(exclude_modules) $$(static_modules)), \
			$$(addprefix $(mods)/, $$(include_modules) )) ))
else	
	# Standard, old resultant set
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_noinc=$$(filter-out $$(addprefix $(mods)/, \
			$$(exclude_modules) $$(static_modules)), $$($(mods)_all)) \
))
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)=$$(filter-out $$(modules_noinc), \
			$$(addprefix $(mods)/, $$(include_modules) )) $$($(mods)_noinc) \
))
endif # ifneq($(group_include),)
endif # ifneq($(modules_configured),1)

$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_names=$$(shell echo $$($(mods))| \
				sed -e "s/$(mods)"'\/\([^/ ]*\)\/*/\1.so/g' ) \
))
$(foreach mods,$(modules_dirs),$(eval \
	$(mods)_basenames:=$$(shell echo $$($(mods))| \
				sed -e "s/$(mods)"'\/\([^/ ]*\)\/*/\1/g' ) \
))

# all modules from all the $(modules_dirs)
all_modules_lst=$(foreach mods,$(modules_dirs), $($(mods)_all))

# compile modules list (all the compiled mods from  $(modules_dirs))
cmodules=$(foreach mods,$(modules_dirs), $($(mods)))

#modules_names=$(patsubst modules/%, %.so, $(modules))
#modules_full_path=$(join  $(modules), $(addprefix /, $(modules_names)))



# list of utils directories that should be compiled by make utils
C_COMPILE_UTILS=	utils/kamcmd
# list of binaries that should be installed alongside
# (they should be created after make utils, see C_COMPILE_UTILS)
C_INSTALL_BIN=	# kamcmd is now installed by ctl

# which utils know to install themselves and should be installed
# along the core (list of utils directories)
ifeq ($(FLAVOUR),kamailio)
C_INSTALL_UTILS= utils/kamctl
else
C_INSTALL_UTILS=
endif
# list of scripts that should be installed along the core 
# (here a script is something that doesn't have a Makefile)
C_INSTALL_SCRIPTS=
# list of extra configs that should be installed along the core
# Note: all the paths of the form /usr/*lib/$(CFG_NAME)/<module_dir>
# will be updated to the directory where the modules will be installed.
C_INSTALL_CFGS=
# list of files that should be installed in the arch-independent 
# directory (by default /usr/local/share/$(MAIN_NAME)))
C_INSTALL_SHARE=




NAME=$(MAIN_NAME)

tar_name=$(NAME)-$(RELEASE)_src

tar_extra_args+=$(addprefix --exclude=$(notdir $(CURDIR))/, \
					$(auto_gen) $(auto_gen_others))
ifeq ($(CORE_TLS), 1)
	tar_extra_args+=
else
	tar_extra_args+=--exclude=$(notdir $(CURDIR))/tls/* 
endif

ifneq ($(nodeb),)
	tar_extra_args+=--exclude=$(notdir $(CURDIR))/debian 
	tar_name:=$(tar_name)_nodeb
endif

# sanity checks
ifneq ($(TLS),)
        $(warning "make TLS option is obsoleted, try TLS_HOOKS or CORE_TLS")
endif

# include the common rules
include Makefile.rules

#extra targets 

$(NAME): $(extra_objs) # static_modules

lex.yy.c: cfg.lex cfg.tab.h $(ALLDEP)
	$(LEX) $<

cfg.tab.c cfg.tab.h: cfg.y  $(ALLDEP)
	$(YACC) $(YACC_FLAGS) $<

nullstring=
space=$(nullstring) $(nullstring)

modules_search_path=$(subst $(space),:,$(strip\
						$(foreach m,$(modules_dirs),$($(m)_target))))
		#				$(addprefix $(modules_target),$(modules_dirs))))

# special depends for main.o
main.o: DEFS+=-DMODS_DIR='"$(modules_search_path)"'


#special depends for ver.c
ver.d ver.o: autover.h

include Makefile.shared

ifeq ($(config_mak),1)

include Makefile.cfg

# fix basedir path (relative -> absolute)
ifneq (,$(basedir))
ifeq (,$(filter /%, $(basedir)))
override basedir:=$(CURDIR)/$(basedir)
# remove basedir from command line overrides
MAKEOVERRIDES:=$(filter-out basedir=%,$ $(MAKEOVERRIDES))
endif # (,$(filter /%, $(basedir)))
endif # (,$(basedir))

else ifneq ($(config_mak),skip)

config.mak: Makefile.defs Makefile.groups
	@echo making config...
	@echo "# this file is autogenerated by make cfg" >$@
	@$(call mapf2,cfg_save_var,saved_fixed_vars,$(@))
	@$(call mapf2,cfg_save_var2,saved_chg_vars,$(@))
	@echo "override makefile_defs:=1" >>$@
	@echo "C_DEFS:=\$$(filter-out \$$(DEFS_RM) \$$(extra_defs),\$$(C_DEFS))" \
					"\$$(extra_defs)"  >>$@
	@echo "CFLAGS:=\$$(filter-out \$$(CFLAGS_RM) \$$(CC_EXTRA_OPTS)," \
						"\$$(CFLAGS)) \$$(CC_EXTRA_OPTS)" >>$@

endif # ifeq ($(config_mak),1)

modules.lst: Makefile.groups
	@echo  saving modules list...
	@echo "# this file is autogenerated by make modules-cfg" >$@
	@echo >>$@
	@echo "# the list of sub-directories with modules" >>$@
	@echo "modules_dirs:=$(modules_dirs)" >>$@
	@echo >>$@
	@echo "# the list of module groups to compile" >>$@
	@echo "cfg_group_include=$(group_include)" >>$@
	@echo >>$@
	@echo "# the list of extra modules to compile" >>$@
	@$(call cfg_save_var2,include_modules,$@)
	@echo >>$@
	@echo "# the list of static modules" >>$@
	@$(call cfg_save_var2,static_modules,$@)
	@echo >>$@
	@echo "# the list of modules to skip from compile list" >>$@
	@$(call cfg_save_var2,skip_modules,$@)
	@echo >>$@
	@echo "# the list of modules to exclude from compile list" >>$@
	@$(call cfg_save_var3,exclude_modules,skip_modules,$@)
	@echo >>$@
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods)_all,$@))
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods)_noinc,$@))
	@$(foreach mods,$(modules_dirs), \
		$(call cfg_save_var2,$(mods),$@))
	@echo "modules_configured:=1" >>$@


.PHONY: cfg config cfg-defs
cfg-defs: config.mak

cfg config: cfg-defs modules-cfg

.PHONY: modules-cfg modules-list modules-lst
modules-cfg modules-list modules-lst:
	rm -f modules.lst
	$(MAKE) modules.lst

ifneq ($(wildcard .git),)
# if .git/ exists
repo_ver=$(shell  RV=`git rev-parse --verify --short=6 HEAD 2>/dev/null`;\
					[ -n "$$RV" ] && \
					test -n "`git update-index --refresh --unmerged >/dev/null\
							; git diff-index --name-only HEAD 2>/dev/null | \
								grep -v Makefile`" &&\
						RV="$$RV"-dirty; echo "$$RV")
repo_hash=$(subst -dirty,,$(repo_ver))
repo_state=$(subst %-dirty,dirty,$(findstring -dirty,$(repo_ver)))
autover_h_dep=.git $(filter-out $(auto_gen), $(sources)) cfg.y cfg.lex Makefile
else
# else if .git/ does not exist
repo_ver=
repo_hash="unknown"
repo_state=
autover_h_dep=
endif


autover.h: $(autover_h_dep)
	@echo  "generating autover.h ..."
	@echo "/* this file is autogenerated by make autover.h" >$@
	@echo " * DO NOT EDIT IT" >>$@
	@echo " */" >>$@
	@echo "" >>$@
	@echo "#define REPO_VER \"$(repo_ver)\"" >>$@
	@echo "#define REPO_HASH \"$(repo_hash)\"" >>$@
	@echo "#define REPO_STATE \"$(repo_state)\"" >>$@

.PHONY: all
all: $(NAME) every-module

.PHONY: print-modules
print-modules:
	@echo The following modules were chosen to be included: \
		$(include_modules) ; \
	echo ---------------------------------------------------------- ; \
	echo The following modules will be excluded: $(exclude_modules) ; \
	echo ---------------------------------------------------------- ; \
	echo The following modules will be made; \
	$(foreach mods,$(modules_dirs), \

=== debian/changelog ===
kamailio (4.3.1-2ubuntu1) wily; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Build modules on any platform.
      + Use db-upgrade-util instead of hard coding dbX.Y-util
        dependency.
    - debian/control, debian/rules:
      + Don't try to build the mono module on arm64.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sun, 16 Aug 2015 01:33:36 +0200

kamailio (4.3.1-2) unstable; urgency=medium

  * [3c416e8] add kamcmd patch for reproducible builds

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Wed, 12 Aug 2015 08:46:43 +0200

kamailio (4.3.1-1) unstable; urgency=medium

  * [74a6255] kamailio.init: use NAME and chown HOMEDIR just after create it
  * [9af988a] Imported Upstream version 4.3.1
  * [95a4304] remove already applied upstream patches
  * [f155ce3] refresh debian patches
  * [60a7dd9] upstream patch supporting repoducible builds
  * [198047d] remove auto-generated tls certs
  * [33b7028] add upstream fixes

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Tue, 11 Aug 2015 13:30:43 +0200

kamailio (4.3.0-1ubuntu1) wily; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Build modules on any platform.
      + Use db-upgrade-util instead of hard coding dbX.Y-util
        dependency.
    - debian/control, debian/rules:
      + Don't try to build the mono module on arm64.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sat, 04 Jul 2015 11:28:25 +0200

kamailio (4.3.0-1) unstable; urgency=medium

  * [45ed887] Imported Upstream version 4.3.0
  * [c2d68d8] add upstream patches from 4.3 branch

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Sat, 27 Jun 2015 14:57:38 +0200

kamailio (4.3.0~rc0-1) experimental; urgency=medium

  * [bfe18eb] Imported Upstream version 4.3.0~rc0
  * [6dba838] add new modules on 4.3
  * [a395fc4] update default private memory to 8Mb
  * [0bb4a0c] add new modules to rules and update FLAGS
  * [aa29319] debian/patches: remove applied patches upstream

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Fri, 29 May 2015 11:52:15 +0200

kamailio (4.2.5-1ubuntu1) wily; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - debian/control:
      + Build modules on any platform.
      + Use db-upgrade-util instead of hard coding dbX.Y-util
        dependency.
    - debian/control, debian/rules:
      + Don't try to build the mono module on arm64.

 -- Artur Rona <ari-tczew@ubuntu.com>  Sat, 23 May 2015 23:06:07 +0200

kamailio (4.2.5-1) unstable; urgency=medium

  * [a1f426d] Imported Upstream version 4.2.5
  * [5cfb580] fix FTBFS on powerpcspe because of AltiVec assumption.
    Thanks to Roland Stigge <stigge@antcom.de> (Closes: #729635)
  * [a10699c] set Architecture: any when possible
  * [58c114b] set Architecture: linux-any for sctp related
  * [4ac4845] add powerpcspe to the list of architectures supported by mono module
  * [bc35a5c] kamailio-berkeley-modules: fix lintian warning for empty dir
  * [953678a] debian/control: wrap-and-short and some minor changes to descriptions
  * [f57bbbb] debian/patches: add fix_manpage.patch fixing lintian warnings
  * [8670eb9] debian/copyright: fix lintian warning

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Tue, 19 May 2015 22:29:42 +0200

kamailio (4.2.4-1) unstable; urgency=medium

  * [280cb6a] Imported Upstream version 4.2.1
  * [9fb944e] Imported Upstream version 4.2.4 (Closes: 783946)
  * [0241997] exclude obsoleted and ser examples (Closes: #772314)
  * [a295c13] update Standards-Version to 3.9.6

 -- Victor Seva <linuxmaniac@torreviejawireless.org>  Sun, 03 May 2015 10:19:54 +0200

=== debian/control ===
Source: kamailio
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders: Victor Seva <linuxmaniac@torreviejawireless.org>,
           Tzafrir Cohen <tzafrir@debian.org>
Build-Depends: bison,
               debhelper (>= 9),
               docbook-xml,
               dpkg-dev (>= 1.16.1.1),
               erlang-dev,
               flex,
               gcj-jdk,
               libconfuse-dev,
               libcurl4-openssl-dev,
               libdb-dev (>= 4.6.19),
               libev-dev,
               libevent-dev,
               libexpat1-dev,
               libfreeradius-client-dev,
               libgeoip-dev (>= 1.4.5),
               libhiredis-dev (>= 0.10.0),
               libjansson-dev,
               libjson-c-dev,
               libldap2-dev,
               liblua5.1-0-dev,
               libmemcached-dev,
               libmono-2.0-dev [!ia64 !mips !arm64],
               libmysqlclient-dev,
               libncurses5-dev,
               libpcre3-dev,
               libperl-dev,
               libpq-dev,
               libpurple-dev,
               librabbitmq-dev,
               libreadline-dev,
               libsasl2-dev,
               libsctp-dev [linux-any],
               libsnmp-dev,
               libsqlite3-dev,
               libunistring-dev,
               libval-dev,
               libxml2-dev,
               openssl,
               pkg-config,
               python,
               python-dev,
               unixodbc-dev,
               uuid-dev,
               xsltproc,
               zlib1g-dev
Standards-Version: 3.9.6
Homepage: http://www.kamailio.org/
Vcs-git: git://anonscm.debian.org/pkg-voip/kamailio.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-voip/kamailio.git

Package: kamailio
Architecture: any
Multi-Arch: foreign
Pre-Depends: ${misc:Pre-Depends}
Depends: adduser,
         python,
         ${misc:Depends},
         ${shlibs:Depends}
Suggests: kamailio-berkeley-modules,
          kamailio-carrierroute-modules,
          kamailio-cpl-modules,
          kamailio-ldap-modules,
          kamailio-lua-modules,
          kamailio-mono-modules,
          kamailio-mysql-modules,
          kamailio-perl-modules,
          kamailio-postgres-modules,
          kamailio-presence-modules,
          kamailio-python-modules,
          kamailio-radius-modules,
          kamailio-redis-modules,
          kamailio-snmpstats-modules,
          kamailio-unixodbc-modules,
          kamailio-xml-modules,
          kamailio-xmpp-modules,
          stun-server | turn-server
Provides: sip-router
Description: very fast and configurable SIP proxy
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 C Shell-like scripting language provides full control over the server's
 behaviour. Its modular architecture allows only required functionality to be
 loaded.
 .
 This package contains the main Kamailio binary along with the principal
 modules and support binaries.

Package: kamailio-dbg
Priority: extra
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: very fast and configurable SIP proxy [debug symbols]
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package contains the debugging symbols for the Kamailio binaries and
 modules. You only need to install it if you need to debug Kamailio.

Package: kamailio-geoip-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the geoip module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the geoip module, an extension allowing to
 use GeoIP API within configuration file.

Package: kamailio-sqlite-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: sqlite3
Description: SQLite database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the SQLite database driver for Kamailio.

Package: kamailio-json-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Json parser and jsonrpc modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides json parser for Kamailio's configuration file
 and the JSON-RPC client over netstrings.

Package: kamailio-memcached-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Replaces: kamailio-memcached-module
Description: interface to memcached server
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the memcached module, an interface to the memcached
 server, a high-performance, distributed memory object caching system.

Package: kamailio-lua-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_lua module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_lua module, an extension allowing to
 execute embedded Lua applications within configuration file.

Package: kamailio-mono-modules
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_mono module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_mono module, an extension allowing to
 execute embedded Mono applications within configuration file.

Package: kamailio-python-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         python-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Description: contains the app_python module
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the app_python module, an extension allowing to
 execute embedded Python applications within configuration file.

Package: kamailio-redis-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Redis database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the Redis NOSQL database driver for Kamailio.

Package: kamailio-mysql-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         mysql-client,
         ${misc:Depends},
         ${shlibs:Depends}
Description: MySQL database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the MySQL database driver for Kamailio.

Package: kamailio-postgres-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         postgresql-client,
         ${misc:Depends},
         ${shlibs:Depends}
Description: PostgreSQL database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the PostgreSQL database driver for Kamailio.

Package: kamailio-cpl-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: CPL module (CPL interpreter engine) for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a CPL (Call Processing Language) interpreter for
 Kamailio, turning Kamailio into a CPL server (storage and interpreter).

Package: kamailio-radius-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: RADIUS modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides a set of RADIUS modules for Kamailio, for
 authentication, peering, group membership and messages URIs checking against
 a RADIUS server.

Package: kamailio-unixodbc-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: unixODBC database connectivity module for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides the unixODBC database driver for Kamailio.

Package: kamailio-presence-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: SIMPLE presence modules for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides several Kamailio modules for implementing presence
 server and presence user agent for RICH presence, registrar-based presence,
 external triggered presence and XCAP support.

Package: kamailio-perl-modules
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: kamailio (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Perl extensions and database driver for Kamailio
 Kamailio is a very fast and flexible SIP (RFC3261)
 proxy server. Written entirely in C, Kamailio can handle thousands calls
 per second even on low-budget hardware.
 .
 This package provides an interface for Kamailio to write Perl extensions and
 the perlvdb database driver for Kamailio.

Package: kamailio-snmpstats-modules
Architecture: any

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

DEBVERSION:=$(shell head -n 1 debian/changelog \
                    | sed -e 's/^[^(]*(\([^)]*\)).*/\1/')
UPVERSION:=$(shell dpkg-parsechangelog | sed -ne 's/^Version: \(\([0-9]\+\):\)\?\(.*\)-.*/\3/p')

FILENAME := kamailio_$(UPVERSION).orig.tar.gz
URL := http://www.kamailio.org/pub/kamailio/$(UPVERSION)/src/kamailio-$(UPVERSION)_src.tar.gz

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_HOST_ARCH := $(shell dpkg-architecture -qDEB_HOST_ARCH)

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export JAVA_HOME=/usr/lib/jvm/java-gcj

# choose freeradius
export FREERADIUS=1

# modules not in the "main" kamailio package
EXCLUDED_MODULES=

# extra modules to skip, because they are not compilable now
# - regardless if they go to the main kamailio package or to some module package,
# they will be excluded from compile and install of all
EXTRA_EXCLUDED_MODULES=bdb dbtext oracle pa iptrtpproxy mi_xmlrpc

# module groups that are packaged in seperate packages
# (with the name kamailio-$(group_name)-modules)
# Note: the order is important (should be in dependency order, the one
# on which other depend first)
PACKAGE_GROUPS=mysql postgres berkeley unixodbc radius presence \
			   ldap xml perl utils lua memcached \
			   snmpstats carrierroute xmpp cpl redis python geoip\
			   sqlite json ims sctp java \
			   purple tls outbound websocket autheph dnssec kazoo cnxcc \
			   erlang

# module groups to be packaged onto kamailio-extra-modules
EXTRA_GROUPS=gzcompress uuid ev jansson

# mono not on arm64, ia64 or sparc
ifneq (,$(filter $(DEB_HOST_ARCH),arm64 ia64 sparc))
	override EXCLUDED_MODULES += mono
else ifeq ($(DEB_HOST_ARCH),mips)
        override EXCLUDED_MODULES += mono
else
	override PACKAGE_GROUPS+= mono
endif

# FTBFS on powerpcspe because of AltiVec assumption #729635
ifeq ($(DEB_HOST_ARCH),powerpcspe)
	export NOALTIVEC=1
endif

# name of libdir in the path for libraries (e.g., lib for 32b, lib64 for 64b)
LIBDIR ?= lib/$(DEB_HOST_MULTIARCH)

# directories with possible duplicate libraries (that should be deleted
# from current module* packages)
DUP_LIBS_DIRS=$(CURDIR)/debian/kamailio/usr/$(LIBDIR)/kamailio \
			$(CURDIR)/debian/kamailio-db-modules/usr/$(LIBDIR)/kamailio

# "function" to get package short name out of a dir/module_name
# it also transforms db_foo into foo
mod_name=$(subst db_,,$(lastword $(subst /, ,$(1))))

define PACKAGE_GRP_BUILD_template
	# package all the modules in PACKAGE_GROUPS in separate packages
	$(foreach grp,$(PACKAGE_GROUPS EXTRA_GROUPS),\
		$(MAKE) every-module group_include="k$(grp)" quiet=verbose
	)
endef


define PACKAGE_GRP_INSTALL_template
	$(foreach grp,$(PACKAGE_GROUPS),\
		$(MAKE) install-modules-all LIBDIR=$(LIBDIR) group_include="k$(grp)" \
		BASEDIR=$(CURDIR)/debian/kamailio-$(grp)-modules \
		cfg_prefix=$(CURDIR)/debian/kamailio-$(grp)-modules \
		doc-dir=share/doc/kamailio-$(grp)-modules quiet=verbose
		# eliminate duplicate libs
		-for d in $(DUP_LIBS_DIRS); do \
			test "$$d" != "$(CURDIR)/debian/kamailio-$(grp)-modules/usr/$(LIBDIR)/kamailio" &&\
			for r in `find $$d -name 'lib*'|xargs`; do \
				echo "removing $(grp) lib `basename $$r` present also in $$d";\
				rm -f $(CURDIR)/debian/kamailio-$(grp)-modules/usr/$(LIBDIR)/kamailio/`basename "$$r"` ; \
			done ; \
		done
		find $(CURDIR)/debian/kamailio-$(grp)-modules -depth -empty -type d -exec rmdir {} \;
	)
endef

define PACKAGE_EXTRA_INSTALL_template
	$(foreach grp,$(EXTRA_GROUPS),\
		$(MAKE) install-modules-all LIBDIR=$(LIBDIR) group_include="k$(grp)" \
		BASEDIR=$(CURDIR)/debian/kamailio-extra-modules \
		cfg_prefix=$(CURDIR)/debian/kamailio-extra-modules \
		doc-dir=share/doc/kamailio-extra-modules quiet=verbose
	)
	# eliminate duplicate libs
	-for d in $(DUP_LIBS_DIRS); do \
		test "$$d" != "$(CURDIR)/debian/kamailio-extra-modules/usr/$(LIBDIR)/kamailio" &&\
		for r in `find $$d -name 'lib*'|xargs`; do \
			echo "removing extra lib `basename $$r` present also in $$d";\
			rm -f $(CURDIR)/debian/kamailio-extra-modules/usr/$(LIBDIR)/kamailio/`basename "$$r"` ; \
		done ; \
	done
	find $(CURDIR)/debian/kamailio-extra-modules -depth -empty -type d -exec rmdir {} \;
endef

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# CFLAGS + CPPFLAGS -> CC_EXTRA_OPTS
CC_EXTRA_OPTS := $(shell dpkg-buildflags --get CPPFLAGS)
CC_EXTRA_OPTS += $(shell dpkg-buildflags --get CFLAGS)
CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS)
# LDFLAGS -> LD_EXTRA_OPTS
LD_EXTRA_OPTS := $(shell dpkg-buildflags --get LDFLAGS)

# https://wiki.debian.org/ReproducibleBuilds/
CC_EXTRA_OPTS += -DVERSION_NODATE

configure: configure-stamp
configure-stamp:
	dh_testdir
	# Add here commands to configure the package.
	$(MAKE) FLAVOUR=kamailio cfg prefix=/usr cfg_prefix=$(CURDIR)/debian/kamailio \
			cfg_target=/etc/kamailio/ \
			BASEDIR=$(CURDIR)/debian/kamailio \
			skip_modules="$(EXCLUDED_MODULES) $(EXTRA_EXCLUDED_MODULES)" \
			CC_EXTRA_OPTS="$(CC_EXTRA_OPTS)" \
			LD_EXTRA_OPTS="$(LD_EXTRA_OPTS)" \
			group_include="kstandard" quiet=verbose

	touch configure-stamp


build: build-stamp
build-arch: build-stamp
build-indep: build-stamp
build-stamp: configure-stamp
	dh_testdir
	# Add here commands to compile the package.
	$(MAKE) all quiet=verbose
	# make groups
	$(call PACKAGE_GRP_BUILD_template)
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	# Add here commands to clean up after the build process.
	if [ -r autover.h -a ! -r debian/autover.h ]; then cp -a autover.h debian/; fi
	$(MAKE) maintainer-clean
	if [ -r debian/autover.h -a ! -r autover.h ]; then mv debian/autover.h .; fi
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs
	# Add here commands to install the package into debian/kamailio
	$(MAKE) install LIBDIR=$(LIBDIR) group_include="kstandard"
	# make group packages
	$(call PACKAGE_GRP_INSTALL_template)
	$(call PACKAGE_EXTRA_INSTALL_template)
	# move binaries of kamailio-berkeley-modules to kamailio-berkeley-bin
	mkdir -p $(CURDIR)/debian/kamailio-berkeley-bin/usr/
	mv $(CURDIR)/debian/kamailio-berkeley-modules/usr/sbin \
		$(CURDIR)/debian/kamailio-berkeley-bin/usr/
	# install /etc/default/kamailio file
	mkdir -p $(CURDIR)/debian/kamailio/etc/default
	cp -f debian/kamailio.default $(CURDIR)/debian/kamailio/etc/default/kamailio


# This single target is used to build all the packages, all at once, or
# one at a time. So keep in mind: any options passed to commands here will
# affect _all_ packages. Anything you want to only affect one package
# should be put in another target, such as the install target.
binary-common:
	dh_testdir
	dh_testroot
	dh_installdebconf
	dh_installdocs
	dh_installexamples -Xobsoleted -Xsr
	dh_installmenu
	dh_installinit -pkamailio -- defaults 23
	dh_installcron
	dh_installman
	dh_installinfo
	dh_lintian
	dh_installchangelogs ChangeLog
	dh_link
	dh_strip --dbg-package=kamailio-dbg
	dh_compress
	dh_fixperms
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

# Build architecture-independent packages using the common target
binary-indep: build install
# (Uncomment this next line if you have such packages.)
#        $(MAKE) -f debian/rules DH_OPTIONS=-i binary-common
# We have nothing to do by default.


# Build architecture-dependent packages using the common target
binary-arch: build install
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

# Any other binary targets build just one binary package at a time.
binary-%: build install
	$(MAKE) -f debian/rules binary-common DH_OPTIONS=-p$*

print-version:
	@@echo "Debian version:          $(DEBVERSION)"
